#!/usr/bin/perl

################################################################################
#    Config 1.0. Configuration Server for an Exim Mailsystem                   #
#    Using DB Framwork for PHP  1.1.                                           #
#    Copyright (C) 2006 Luca Bertoncello                                       #
#    Hartigstrasse, 12 - 01127 Dresden Deutschland                             #
#    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       #
#    http://www.lucabert.de/  http://www.lucabert.com/                         #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; version 2 of the License.                   #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; if not, write to the Free Software               #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
################################################################################

use DBI;
use File::Basename;

if($ARGV[0] eq '')
{
  print "Usage:\nmanageAccount.pl <path to node_config.php>\n";
  exit(-1);
}

open(CFG, $ARGV[0]);
@cfgs = <CFG>;
close(CFG);
$mailboxType = 'MAILDIR';
$user = getConfigVar("['MBOXCONFIG']['EXIMUSER']", @cfgs);
$dbHost = getConfigVar("['DATABASE']['SERVER']", @cfgs);
$dbUser = getConfigVar("['DATABASE']['USER']", @cfgs);
$dbPass = getConfigVar("['DATABASE']['PASSWORD']", @cfgs);
$dataBase = getConfigVar("['DATABASE']['DATABASE']", @cfgs);

($mailDB = DBI->connect("DBI:mysql:dbname=$dataBase;host=$dbHost", $dbUser, $dbPass)) or die DBI::errstr;

# Create new accounts
$sth = $mailDB->prepare("SELECT accountname, finaldest, finaldestSpam, uid FROM account WHERE virtual = 'f' AND toActivate = 't'");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $finaldest = $values[1];
  $finaldestSpam = $values[2];
  $uidU = $values[3];
  ($login, $pass, $uid, $gid) = getpwnam($user);
  $uid = $uidU if($uidU != 0);
  print "Create [$accountname]...\n";
  if($mailboxType eq 'MBOX')
  {
    system("/usr/bin/touch $finaldest");
    system("/usr/bin/touch $finaldestSpam");
    chown $uid, $gid, "$finaldest";
    chown $uid, $gid, "$finaldestSpam";
  }
  if($mailboxType eq 'MAILDIR')
  {
    $homeDir = $finaldest;
    $homeDir =~ s/\/Maildir/\/home/g;
    system("/bin/mkdir -p $homeDir");
    system("/bin/mkdir -p $finaldest/new");
    system("/bin/mkdir -p $finaldest/cur");
    system("/bin/mkdir -p $finaldest/tmp");
    system("/bin/mkdir -p $finaldest/.Sent/new");
    system("/bin/mkdir -p $finaldest/.Sent/cur");
    system("/bin/mkdir -p $finaldest/.Sent/tmp");
    system("/bin/mkdir -p $finaldestSpam/new");
    system("/bin/mkdir -p $finaldestSpam/cur");
    system("/bin/mkdir -p $finaldestSpam/tmp");
    system("/bin/mkdir -p $finaldest/.Trash/new");
    system("/bin/mkdir -p $finaldest/.Trash/cur");
    system("/bin/mkdir -p $finaldest/.Trash/tmp");
    chown $uid, $gid, "$homeDir";
    chown $uid, $gid, "$finaldest";
    chown $uid, $gid, "$finaldest/new";
    chown $uid, $gid, "$finaldest/cur";
    chown $uid, $gid, "$finaldest/tmp";
    chown $uid, $gid, "$finaldest/.Sent";
    chown $uid, $gid, "$finaldest/.Sent/new";
    chown $uid, $gid, "$finaldest/.Sent/cur";
    chown $uid, $gid, "$finaldest/.Sent/tmp";
    chown $uid, $gid, "$finaldestSpam";
    chown $uid, $gid, "$finaldestSpam/new";
    chown $uid, $gid, "$finaldestSpam/cur";
    chown $uid, $gid, "$finaldestSpam/tmp";
    chown $uid, $gid, "$finaldest/.Trash";
    chown $uid, $gid, "$finaldest/.Trash/new";
    chown $uid, $gid, "$finaldest/.Trash/cur";
    chown $uid, $gid, "$finaldest/.Trash/tmp";
    open(SUB, "> $finaldest/subscriptions");
    print SUB "Trash\nSpam\nSent\n";
    close(SUB);
    chown $uid, $gid, "$finaldest/subscriptions";
    system("/bin/chmod -R a+rx $finaldest");
    system("/bin/chmod -R g+rx $finaldest");
    system("/bin/chmod -R g+s $finaldest");
  }
  $sthU = $mailDB->prepare("UPDATE account SET toActivate = 'f' WHERE accountname = '$accountname'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
}
$sth->finish();

# Delete old accounts
$sth = $mailDB->prepare("SELECT accountname, finaldest, finaldestSpam FROM account WHERE toDelete = 't'");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $finaldest = $values[1];
  $finaldestSpam = $values[2];
  print "Delete [$accountname]...\n";
  if($mailboxType eq 'MBOX')
  {
    system("/bin/rm -Rf $finaldest");
    system("/bin/rm -Rf $finaldestSpam");
  }
  if($mailboxType eq 'MAILDIR')
  {
    $mainDir = $finaldest;
    $mainDir =~ s/\/Maildir//g;
    system("/bin/rm -Rf $finaldestSpam");
    system("/bin/rm -Rf $finaldest");
    system("/bin/rm -Rf $mainDir");
  }
  $sthU = $mailDB->prepare("DELETE FROM aliases WHERE accountname = '$accountname'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
  $sthU = $mailDB->prepare("DELETE FROM account WHERE accountname = '$accountname'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
}
$sth->finish();

$mailDB->disconnect();

sub getConfigVar
{
  my($varName, @cfgs) = @_;

  $varName =~ s/\[/\\\[/g;
  $varName =~ s/\]/\\\]/g;
  $varName =~ s/\'/\\\'/g;
  @fs = grep(/$varName/, @cfgs);
  $v = $fs[$#fs];
  $v =~ s/[\n\r]//g;
  ($x, $var) = split(/=/, $v);
  $var =~ s/\ //g;
  $var =~ s/\;//g;
  $var =~ s/\'//g;

  return($var);
}
