<?php
/**
 * Config E-Mail
 * 
 * Autor: Luca Bertoncello <lucabert@lucabert.de>
 */

function __autoload($class)
{
  require_once(dirname(__FILE__).'/../incs/'.$class.'.php');
}

define("PAGE_ERROR",            'http://'.$_SERVER['SERVER_NAME'].'/errorpages/syserror.php');

require_once(dirname(__FILE__).'/../3rdpartypacks/myMVC/myMVC.php');
require_once(dirname(__FILE__).'/../etc/etc.php');

myMVC_ErrorHandler::setUserExceptionCatcher('Errors::sysError');

$controller = new myMVC_Controller();
$controller->setRenderEngine(new myMVC_SmartyEngine(dirname(__FILE__).'/../pages/templates',
                                                    dirname(__FILE__).'/../pages/templates_c'));
$controller->setActions(array('MainAction', 'SysErrorAction', 'NoRightsAction',
                              'LoginAction', 'LogoutAction',
                              'ManageDomainAction', 'ManageListAction', 'ManageAliasAction',
                              'ManageFilterAction', 'ManageUserAction', 'AutoresponderAction'),
                              'MainAction', 'NoRightsAction');
$controller->setViews(array('SysErrorView', 'NoRightsView', 'MainView', 'LoginView',
                            'ManageDomainView', 'ManageListView', 'ManageAliasView',
                            'ManageFilterView', 'AutoresponderView', 'ManageUserView',
                            'SearchView'));

$controller->setLanguageInformation(array('de_DE' => 'Deutsch',
                                          'en_US' => 'English',
                                          'it_IT' => 'Italiano'),
                                    'de_DE',
                                    $_SERVER['DOCUMENT_ROOT'].'/../locale', 'configEMail');

$controller->setFilter(myMVC_Controller::$FILTER_PREACTION, 'myMVC_LoginFilter', array(),
        array('loginAction' => 'LoginAction'));

// Damit auf der Seiten auch die Versionsnummer zu sehen ist
$session = myMVC_HttpSession::getInstance();
$session->setInNamespace('main', 'version', CURRENTVERSION);

$controller->process();
?>